.\"	$NetBSD: hdaudioctl.8,v 1.1 2009/10/11 08:57:54 sborrill Exp $
.\"
.\" Copyright (c) 2009 Precedence Technologies Ltd <support@precedence.co.uk>
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Precedence Technologies Ltd
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd October 6, 2009
.Dt HDAUDIOCTL 8
.Os
.Sh NAME
.Nm hdaudioctl
.Nd program to manipulate
.Xr hdaudio 4
devices.
.Sh SYNOPSIS
.Nm hdaudioctl
.Op Ar -f device
.Ar command
.Op Ar arguments
.Sh DESCRIPTION
The
.Nm
command can be used to inspect and reconfigure High Definition Audio devices
and their child codecs.
.Pp
The mandatory
.Ar command
argument specifies the action to take.
Valid commands are:
.Bl -tag -width XgetXcodecidXnidX
.It list
For each child codec of the chosen
.Xr hdaudio 4
device, display the nid, vendor, product, subsystem and device IDs.
.It get Ar codecid Ar nid
Retrieve and display the current codec configuration as a
.Xr proplib 3
XML plist.
.It set Ar codecid Ar nid Op Ar plist
Detach the specified
.Xr hdafg 4
codec and then re-attach with its widgets explicitly configured according to
the specified plist.
If no plist is given, the in-built widget parsing rules based on the High
Definition Audio specification will be used.
.It graph Ar codecid Ar nid
Output a DOT file suitable processing by graphviz.
The resulting image will graphically show the structure and interconnections
of the widgets that form the chosen
.Xr hdafg 4
codec.
.El
.Sh FILES
.Bl -tag -width /dev/hdaudioX -compact
.It Pa /dev/hdaudioX
control devices
.El
.Sh SEE ALSO
.Xr audio 4 ,
.Xr hdaudio 4 ,
.Pa pkgsrc/graphics/graphviz
.Sh HISTORY
The
.Nm
command first appeared in
.Nx 5.1 .
.Sh AUTHORS
.Nm
is based on two separate programs written by
.An Jared McNeill Aq jmcneill@NetBSD.org
under contract by
.An Precedence Technologies Ltd Aq http://www.precedence.co.uk/ .
Integration into one program and writing this manual page was done by
.An Stephen Borrill Aq sborrill@NetBSD.org .
.Sh CAVEATS
When a plist is loaded and the
.Xr hdafg 4
codec reattaches, all mixer controls will be returned to their default values.
